use <screwthread_v2.scad>
use <screw.scad>


$fn=100;

t1D0   = 39;//1.25*25.4;  // 调焦筒内径1.25英寸 = 31.75
t1D1   = t1D0 + 16;  // 调焦筒外径1.25英寸 + 16mm = 47.75mm
t1ALen = 125; // 调焦筒总长度
t1RLen = 115; // 调焦筒插入部分长度

t2D0 = t1D1 + 2;    // 调焦外筒内径 = 49.75mm
t2D1 = t2D0 + 18.25;   // 调焦外筒外径 = 68mm
t2Len= 50;         // 调焦外筒长度 = 50mm
t2ExtLen= 70;      // 调焦座含有的镜身部分长度
t2DS = t2D0 + 8.5; // 调焦外筒安装螺纹外径

TND = 68;   // 镜筒内径

SCREW_PITCH = 2;    // 螺距
ScrewLen = 4;       // 安装螺纹长度，实际长度略长于螺距 X ScrewLen


module  Plug(PD) {
    module  pb(d, h) {
        difference() {
            cylinder(d=d, h=h);
            rotate_extrude() {
                translate([d/2-1.9,0,-0.01])
                polygon([[2,0],[2,2],[0,0]]);
            }
        }
    }
    
    difference() {
        union() {
            difference() {
                union() {
                    pb(PD, 12);
                    translate([0,0,12])
                    cylinder(d2=PD+4, d1=PD, h=2.1);
                }
                translate([0,0,1.5]) pb(PD-3, 16);
            }
            translate([0,0,8])cube([2.5,PD-1,12], center=true);
        }
    }
}
//Plug(23.15);
//Plug(38.8);

module Cap(d=48) {
    difference() {
      union() {
        difference() {
          cylinder(d=d+3.4, h=10);
          translate([0,0,1.5])  cylinder(d=d+1, h=50);
        }
      }
    }
    
    
    for (i=[0:45:355]) {
        rotate(i, [0,0,1])
        translate([(d+3)/2-0.85,0, 4.6])
        color("yellow") {
            cylinder(d=1.15, h=7, center=true);
            translate([0,0,3.5]) sphere(d=1.15, center=true);
        }
    }
}
Cap(39);

module DCap(d=23.2, dl=30) {
  module  mask(d) {
    translate([0,0,1.5])  cylinder(d=d+1, h=50);
  }
  module  am(d) {
    for (i=[0:45:355]) {
        rotate(i, [0,0,1])
        translate([(d+3)/2-0.85,0, 4.6])
        color("yellow") {
            cylinder(d=1.15, h=6, center=true);
            translate([0,0,3]) sphere(d=1.15, center=true);
        }
    }
  }
  //am(d);
  difference() {
    union() {
      translate([-dl/2,0,0]) cylinder(d=d+3.4, h=10);
      translate([ dl/2,0,0]) cylinder(d=d+3.4, h=10);
      translate([0,0,5])cube([dl, d, 10], center=true);
    }
    translate([-dl/2,0,0]) mask(d);
    translate([ dl/2,0,0]) mask(d);
  }
  translate([-dl/2,0,0]) am(d);
  translate([ dl/2,0,0]) am(d);
}

//translate([0, 20,0])DCap(27.92, 31);
//translate([0, 53,0])DCap(23.2,  31);
//translate([0, -20,0])DCap(34.91, 38);
//translate([0,-57,0])DCap(23.2,  38);





module  linkTong() {
  tlen = 30;
  difference() {
    union() {
      difference() {
        union() {
          cylinder(d=t2D1, h=15.01);
          translate([0,0,15])
          cylinder(d1=t2D1, d2=87, h=tlen-15+0.01);
          translate([0,0,tlen])
          color("red") {
            difference() {
              cylinder(d=78.2, h=12);
              translate([0,0,-1]) cylinder(d=74, h=22);
            }
            difference() {
              cylinder(d=87, h=12);
              translate([0,0,-1]) cylinder(d=83.3, h=22);
            }
          }
        }
    
        translate([0,0,-0.1]) {
          //cylinder(d=TND, h=tlen+20);
          thread(SCREW_PITCH, TND + SCREW_PITCH+0.9, 5, ScrewLen+3);
          translate([0,0,15])
          cylinder(d1=TND, d2=75, h=tlen-15+0.12);
        }
      }
      translate([0,0,tlen+6]) {
        translate([38,0,0])rotate(-90,[0,1,0])
        cylinder(d1=12,d2=7,h=3);
        rotate(120,[0,0,1])
        translate([38,0,0])rotate(-90,[0,1,0])
        cylinder(d1=12,d2=7,h=3);
        rotate(-120,[0,0,1])
        translate([38,0,0])rotate(-90,[0,1,0])
        cylinder(d1=12,d2=7,h=3);
      }
    }
    translate([0,0,tlen+6]) {
      translate([48,0,0])rotate(-90,[0,1,0]) {
        cylinder(d=3.2, h=40);
        translate([0,0,14-3])
        cylinder(d=6.4, h=10, $fn=6);
        translate([0,0,4.3])
        cylinder(d1=6.6,d2=3.2, h=1.6);
      }
      rotate(120,[0,0,1])
      translate([48,0,0])rotate(-90,[0,1,0]) {
        cylinder(d=3.2, h=40);
        translate([0,0,14-3])
        cylinder(d=6.4, h=10, $fn=6);
        translate([0,0,4.3])
        cylinder(d1=6.6,d2=3.2, h=1.6);
      }
      rotate(-120,[0,0,1])
      translate([48,0,0])rotate(-90,[0,1,0]) {
        cylinder(d=3.2, h=40);
        translate([0,0,14-3])
        cylinder(d=6.4, h=10, $fn=6);
        translate([0,0,4.3])
        cylinder(d1=6.6,d2=3.2, h=1.6);
      }
    }
  }
}
//linkTong();

//bz();
module  bz() {
  
  difference() {
    cylinder(d=16, h=5.0);
    translate([0,0,-1])
    cylinder(d=5.1, h=10);
    translate([8-2,0,2.5])
    rotate(90,[0,1,0])cylinder(d=3, h=5);
  
    difference() {
      translate([-15,0,3])
      cube([25,30,10], center=true);
      translate([0,0,-10])
      cylinder(d=15,h=50);
    }
  }
}

//rotate(180,[0,1,0])
//tjBody(0);
// 调焦座本体连同调焦筒的总体有效长度为1+5+7=13cm
module  tjBody(sf=0) {
    t2SLen=15;
    gdLen = 5;
  
    difference() {
        union() {
            //color("red")
            cylinder(d=t2D1, h=t2Len);
            
            translate([0,0,t2Len-0.01]) {
                //cylinder(d1=t2D1, d2=TND, h= gdLen);
                    //cylinder(d=TND, h=15);

                thread(
                    SCREW_PITCH, 
                    TND + SCREW_PITCH-0.2,
                    5,
                    ScrewLen+1
                );
              
            }
            translate([-t2D1/2+5, 0, 27]) {
              cube([12, 44,37], center=true);
              translate([-6,0,-10])color("yellow")
              hull() {
                cube([0.01, 44,17], center=true);
                translate([9,0,-7.0])
                cube([0.01, 44,17], center=true);
              }
            }
        }
        /*
            translate([21,0,27]) rotate(90, [0,1,0])
            cylinder(d=10, h=9.5);  
            for(i=[90:30:270]) {
              if (i!=180) {
                rotate(i,[0,0,1])
                color("red")
                translate([-t2D1/2-2.5,0,-5]) {
                  cylinder(d=15,h=40);
                  translate([0,0,40]) sphere(d=15, center=true);
                }
              }
            }
        */
          
        translate([0,0,-5]) 
        cylinder(d=t2D0, h=t2Len + t2SLen +50);
        
        translate([23.5+4,0,27]) rotate(90, [0,1,0]){
            color("blue")cylinder(d=4.3, h=20);  
            color("red")cylinder(d=8.4, h=5, $fn=6);
        }
        color("green")
        translate([22.6,0,27])
        cube([1.5,8,40], center=true);
        
        
        translate([-t2D0/2-0.3,0,(t2Len+t2SLen)/2])
        color("red")
        cube([7, 5.3, t2Len+t2SLen+50], center=true);
            
        rotate(-90, [0,0,1])  
        translate([0,-36, 27]) 
        shoulun(0.5, 50);
        

        // M3螺丝孔 X 4
        translate([-18,-16,39.5])
        rotate(90, [0,1,0])
        color("red") {
          cylinder(d=3.2, h=50, center=true);
          translate([0,0,-20.625+4])cylinder(d=6.4, h=15, $fn=6);
        }

        translate([-18,16,39.5])
        rotate(90, [0,1,0])
        color("red") {
          cylinder(d=3.2, h=50, center=true);
          translate([0,0,-20.625+4])cylinder(d=6.4, h=15, $fn=6);
        }

        translate([-18,-16,14.5])
        rotate(90, [0,1,0])
        color("red") {
          cylinder(d=3.2, h=50, center=true);
          translate([0,0,-20.625+4])cylinder(d=6.4, h=15, $fn=6);
        }

        translate([-18,16,14.5])
        rotate(90, [0,1,0])
        color("red") {
          cylinder(d=3.2, h=50, center=true);
          translate([0,0,-20.625+4])cylinder(d=6.4, h=15, $fn=6);
        }

        // 手轮让位坑
        rotate(-90, [1,0,0])
        translate([-t2D0/2-6, -27, 33])
        color("green")
        cylinder(d=35, h=15, center=true);
        rotate(-90, [1,0,0])
        translate([-t2D0/2-6, -27,-33])
        color("green")
        cylinder(d=35, h=15, center=true);

        // 调焦管支撑钢条安装位 X 4
        rotate(135, [0,0,1])
        translate([t2D0/2 + 0.54,0, 31.5])
        color("blue") {
            cylinder(d=3.1, h=61, center=true); 
            translate([-1.6,0,0])
            cube([3.1, 3.1, 61], center=true);
        }
        rotate(225, [0,0,1])
        translate([t2D0/2 + 0.54,0, 31.5])
        color("blue") {
            cylinder(d=3.1, h=61, center=true); 
            translate([-1.6,0,0])
            cube([3.1, 3.1, 61], center=true);
        }
        rotate(45, [0,0,1])
        translate([t2D0/2 + 0.54,0, 31.5])
        color("blue") {
            cylinder(d=3.1, h=61, center=true); 
            translate([-1.6,0,0])
            cube([3.1, 3.1, 61], center=true);
        }
        rotate(-45, [0,0,1])
        translate([t2D0/2 + 0.54,0, 31.5])
        color("blue") {
            cylinder(d=3.1, h=61, center=true); 
            translate([-1.6,0,0])
            cube([3.1, 3.1, 61], center=true);
        }

        
        rotate_extrude() {
            translate([-t2D1/2,0,0])
            polygon([[0,2],[0,0],[2,0]]);
        }
        
    }
    
    
    if (sf==1) {
        translate([-t2D0/2-0.3,0,(t2Len+t2SLen)/2])
        color("green")
        cube([5, 5, t2Len+t2SLen+10], center=true);
    }

}



//调焦座手轮压盖
//translate([24, 0,106.5])  rotate(-90, [0, 1, 0])  handGai();
//调焦座手轮压盖
module handGai() {
    difference() {
        translate([-99.5, 0, 24]) 
        cube([12, 44,37], center=true);        
      
        rotate(90, [0,0,1])  
        translate([0,93.5, 24]) 
        shoulun(0.5, 20);
    
        //调节顶丝孔 X 2
        translate([-100,13.0,24])
        rotate(90, [0,1,0])
        color("blue")
        cylinder(d=3.2, h=20, center=true);

        translate([-100,-13.0,24])
        rotate(90, [0,1,0])
        color("blue")
        cylinder(d=3.2, h=20, center=true);
        
        //调节顶丝孔螺母位孔 X 2
        translate([-94,13.0,24])
        rotate(90, [0,1,0])
        color("green")
        cylinder(d=6.30, h=20, $fn=6, center=true);
    
        translate([-94,-13.0,24])
        rotate(90, [0,1,0])
        color("green")
        cylinder(d=6.30, h=20, $fn=6, center=true);
    
        // M3螺丝孔 X 4
        translate([-100,-16,36.5])
        rotate(90, [0,1,0])
        color("red")
        cylinder(d=3.2, h=20, center=true);

        translate([-100,16,36.5])
        rotate(90, [0,1,0])
        color("red")
        cylinder(d=3.2, h=20, center=true);

        translate([-100,-16,11.5])
        rotate(90, [0,1,0])
        color("red")
        cylinder(d=3.2, h=20, center=true);

        translate([-100,16,11.5])
        rotate(90, [0,1,0])
        color("red")
        cylinder(d=3.2, h=20, center=true);
        
        //螺丝沉头孔 X 4
        translate([-111,-16,36.5])
        rotate(90, [0,1,0])
        color("red")
        cylinder(d=6, h=20, center=true);

        translate([-111,16,36.5])
        rotate(90, [0,1,0])
        color("red")
        cylinder(d=6, h=20, center=true);
        
        translate([-111,-16,11.5])
        rotate(90, [0,1,0])
        color("red")
        cylinder(d=6, h=20, center=true);
        
        translate([-111,16,11.5])
        rotate(90, [0,1,0])
        color("red")
        cylinder(d=6, h=20, center=true);
        
        
    }
        //translate([-100,-12,-30]) cylinder(d=3.3, h=50);
        //translate([-100, 12,-30]) cylinder(d=3.3, h=50);
        //translate([-100,-12,-23-4]) cylinder(d=6, h=30);
        //translate([-100, 12,-23-4]) cylinder(d=6, h=30);
}

//translate([0,0,10+55])import("tjbody.stl");
//调焦筒
//rotate(180, [0,1,0]) rotate(180, [0,0,1]) translate([0, 0,-t1ALen]) tjTong(0); // 已按fn=100, 输出到tong.stl
//调焦筒安装齿条的部分，有效行程55mm
module  tjTong(st=0) {
    difference() {
        union() {
            translate([0,0,-5])
            cylinder(d=t1D1,   h=t1ALen+5);
            translate([0,0,t1RLen]) 
            cylinder(d=t1D1+8, h=t1ALen-t1RLen);
          
            translate([-t1D1/2+2,2.5,25])
            color("yellow") 
            rotate(90,[1,0,0])cylinder(d=8, h=5);
        }
        translate([0,0,-5]) color("green")
        cylinder(d=t1D0+0.15, h=t1ALen+10);

        translate([0,0,-5.01])  color("red")
        cylinder(d=t1D1-6, h=t1ALen-25);
        
        translate([0,0, t1RLen + (t1ALen-t1RLen)/2]) 
        rotate(90, [0,1,0]) {
            cylinder(d=3.5, h=40);
            translate([0,0,12.6])
            rotate(30,[0,0,1]) 
            cylinder(d=6.5, h=10, $fn=6);
        }

        rotate(120, [0,0,1])
        translate([0,0, t1RLen + (t1ALen-t1RLen)/2]) 
        rotate(90, [0,1,0]) {
            cylinder(d=3.5, h=40);
            translate([0,0,12.6])
            rotate(30,[0,0,1]) 
            cylinder(d=6.5, h=10, $fn=6);
        }

        rotate(240, [0,0,1])
        translate([0,0, t1RLen + (t1ALen-t1RLen)/2]) 
        rotate(90, [0,1,0]) {
            cylinder(d=3.5, h=40);
            translate([0,0,12.6])
            rotate(30,[0,0,1]) 
            cylinder(d=6.5, h=10, $fn=6);
        }
        
        translate([-t1D1/2-1,0,t1RLen/2+5])
        color("green")
        cube([5, 5.1, 68], center=true);

        color("red") translate([0,0,t1ALen-2])
        rotate_extrude() {
            translate([(t1D1+8)/2-1,0,0])
            polygon([[2,2],[2,0],[0,2]]);
        }
        
        translate([0,0,t1ALen-1.6])
        color("yellow")
        rotate_extrude() {
            translate([-t1D0/2+1,0,0])
            polygon([[0,0],[-3,3],[0,3]]);
        }
        
        color("green") translate([0,0,t1ALen-9])
        rotate_extrude() {
            translate([(t1D1+8)/2,0,0])
            polygon([[0,0],[-2,-2],[0,-2]]);
        }

        rotate(35.26,[0,0,1])
        translate([t1D0/2,0,t1ALen-2.5])
        cube([4,1.6,6], center=true);
        rotate(-35.26,[0,0,1])
        translate([t1D0/2,0,t1ALen-2.5])
        cube([4,1.6,6], center=true);
        rotate(180-35.26,[0,0,1])
        translate([t1D0/2,0,t1ALen-2.5])
        cube([4,1.6,6], center=true);
        rotate(-180+35.26,[0,0,1])
        translate([t1D0/2,0,t1ALen-2.5])
        cube([4,1.6,6], center=true);

    }
    //cube([6.5, 5.51, 6], center=true);
    if (st==1) {
        translate([-t1D1/2-1,0,t1RLen/2+7])
        color("green")
        cube([6, 6, t1RLen-32], center=true);
    }
}


// 手轮
//handLun(hlD=35, kD=5.2);  // 已按fn=100, 输出到handLun.stl
// 手轮
module  handLun(hlD=33, kD=5.1, dsD=2.5) {
    difference() {
        union() {
            cylinder(d=hlD, h=28);
            
            for (i=[0:30:355]) {
                rotate(i, [0,0,1])
                translate([hlD/2-2.2 + 0.8,0, 10])
                color("yellow") {
                    cylinder(d=5, h=10, center=true);
                    translate([0,0,5]) sphere(d=5, center=true);
                    translate([0,0,-5]) sphere(d=5, center=true);
                }
            }


            
        }
        translate([0,0,3]) cylinder(d=kD, h=40);
        
        translate([0,0,24])k();
        rotate(120,[0,0,1])translate([0,0,24])k();
        rotate(-120,[0,0,1])translate([0,0,24])k();

        translate([0,0,20]) color("blue")
        difference() {
            cylinder(d=hlD+2, h=22);
            translate([0,0,-1]) cylinder(d=20, h=24);
        }
        
        rotate_extrude() {
            translate([-hlD/2-1.2,0,0])
            polygon([[0,2],[0,0],[2,0]]);
        }
        translate([0,0,18.0]) rotate_extrude() {
            translate([-hlD/2-1.2,0,0])
            polygon([[2,2],[0,0],[0,2]]);
        }
        
        translate([0,0,-1]) cylinder(d1=hlD-8, d2=hlD-12, h=1.8);
    }
  module k(){
    {
      rotate(90,[0,1,0])
      cylinder(d=3.2, h=20);
      translate([5.2,0,6.5]) color("red")
      cube([2.65,5.72,20], center=true);
    }
  }
}



// 调焦手轮模型，用于检查设计，不用输出打印
module  shoulun(fs=0, ls=0){
    rotate(90, [0,1,0]) 
    {
        cylinder(d=5+fs, h=100, center=true);
        if (ls!=0) {
            if (ls>0) {
                translate([0,-ls/2,0])
                cube([5+fs, ls, 100], center=true);
            }
            else {
                translate([0,-ls/2,0])
                cube([5+fs, -ls, 100], center=true);
            }
        }
//        translate([0,0,44]) cylinder(d=15, h=10, center=true);
        //translate([0,0,-44]) cylinder(d=15, h=10, center=true);
        translate([0,0,0])    
        color("red") {
            cylinder(d=12+fs*2, h=5+fs, center=true);
            if (ls!=0) {
                if (ls>0) {
                    translate([0,-ls/2,0])
                    cube([12+fs*2, ls, 5+fs], center=true);
                }
                else {
                    translate([0,-ls/2,0])
                    cube([12+fs*2, -ls, 5+fs], center=true);
                }
            }
        }
        
        translate([0,0,-5]) 
        color("red") {
            cylinder(d=14+fs*2, h=5+fs, center=true);
            if (ls!=0) {
                if (ls>0) {
                    translate([0,-ls/2,0])
                    cube([14+fs*2, ls, 5+fs], center=true);
                }
                else {
                    translate([0,-ls/2,0])
                    cube([14+fs*2, -ls, 5+fs], center=true);
                }
            }
        }
        
        translate([0,0,-13]) 
        color("red") {
            cylinder(d=16.5, h=5.6, center=true);
            if (ls!=0) {
                if (ls>0) {
                    translate([0,-ls/2,0])
                    cube([16.5, ls, 5.6], center=true);
                }
                else {
                    translate([0,-ls/2,0])
                    cube([16.5, -ls, 5.6], center=true);
                }
            }
        }

        translate([0,0,13]) 
        color("red") {
            cylinder(d=16.5, h=5.6, center=true);
            if (ls!=0) {
                if (ls>0) {
                    translate([0,-ls/2,0])
                    cube([16.5, ls, 5.6], center=true);
                }
                else {
                    translate([0,-ls/2,0])
                    cube([16.5, -ls, 5.6], center=true);
                }
            }
        }
    }
}



module screwthread_triangle(P) {
	difference() {
		translate([-sqrt(3)/3*P+sqrt(3)/2*P/8,0,0])
		rotate([90,0,0])
		cylinder(r=sqrt(3)/3*P,h=0.00001,$fn=3,center=true);

		translate([0,-P/2,-P/2])
		cube([P,P,P]);
	}
}

module screwthread_onerotation(P,D_maj,step) {
	H = sqrt(3)/2*P;
	D_min = D_maj - 5*sqrt(3)/8*P;

	for(i=[0:step:360-step])
	hull()
		for(j = [0,step])
		rotate([0,0,(i+j)])
		translate([D_maj/2,0,(i+j)/360*P])
		screwthread_triangle(P);

	translate([0,0,P/2])
	cylinder(r=D_min/2,h=2*P,$fn=360/step,center=true);
}

module thread(P,D,step,rotations) {
    // added parameter "rotations"
    // as proposed by user bluecamel
	for(i=[0:rotations])
	translate([0,0,i*P])
	screwthread_onerotation(P,D,step);
}










